/*
	File Name:	Shared Library.c
*/

#include <CodeFragments.h>
#include "Shared Library.h"

short	gFileRefNum;

/*******************************************************************************

	__initialize

*******************************************************************************/

OSErr __initialize(InitBlockPtr ibp)
{
	OSErr	err = noErr;
	
	gFileRefNum = -1;
	
	//
	// we should always be kDataForkCFragLocator when we are a shared library. assuming
	// this is is the case, we want to open our resource file so we can access
	// our resources if needed. our termination routine will close the file.
	//
	
	if (ibp->fragLocator.where == kDataForkCFragLocator) {
		gFileRefNum = FSpOpenResFile(ibp->fragLocator.u.onDisk.fileSpec, fsRdPerm);
		if (gFileRefNum == -1)
			err = ResError();
	}
	
	return err;
}

/*******************************************************************************

	__terminate

*******************************************************************************/

void __terminate(void)
{
	if (gFileRefNum != -1)
		CloseResFile(gFileRefNum);
}

/*******************************************************************************

	BeepThreeTimes

*******************************************************************************/

void BeepThreeTimes(void)
{
	short		saveResFile = CurResFile();
	DialogPtr 	d;
	
	UseResFile(gFileRefNum);

	d = GetNewDialog(256, nil, (WindowPtr)-1);
	if (d) {
		ShowWindow(d);
		DrawDialog(d);
	}
	
	SysBeep(0);
	SysBeep(0);
	SysBeep(0);
	
	if (d)
		DisposeDialog(d);
	
	UseResFile(saveResFile);
}

/*******************************************************************************

	ShowLibAlert

*******************************************************************************/
#define kAlertID	128
void ShowLibAlert(void)
{
	short	saveResFile = CurResFile();
	UseResFile(gFileRefNum);
	NoteAlert(kAlertID, nil);
	UseResFile(saveResFile);
}