/*
	File Name:	modules.h	
*/

#pragma once

#ifdef __powerc
OSErr 	ExecuteSharedLib(Str255 errName);
#endif
OSErr 	ExecuteResource(void);
OSErr 	Call68k(void);
OSErr 	CallPPC(void);
OSErr 	CallFat(void);
Boolean ChooseCodeContainingFile(FSSpecPtr fsp);
pascal 	Boolean MyFileFilter(CInfoPBPtr cpbp);

// modules are stored in files of a specific type

#define kModuleFileType		'xMOD'

// code is stored in various forms. the data fork of the file also contains the PPC
// only code so it can take advantage of Virtual Memory paging when needed. in your
// application you would not store it in this many forms, but in these examples we
// do in order to show you many of the possibilities.

#define kModule68kResType	'68k '	// resource that contains 68k code only, with no RD
#define kModulePPCResType	'PPC '	// resource that contains PPC code only, with no RD
#define kModuleFatResType	'FAT '	// resource that contains both 68k & PPC code, and has RD

#define kModuleResID		128		// always id 128

typedef long (*ModuleProc)(long inData);

enum {	// 241 = 0xF1
	uppModuleEntryProcInfo = kCStackBased
		 | RESULT_SIZE(SIZE_CODE(sizeof(long)))
		 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(long)))
};

#if USESROUTINEDESCRIPTORS
typedef UniversalProcPtr	ModuleEntryProcUPP;
#define CallModuleEntryProc(userRoutine, params)	\
		CallUniversalProc((UniversalProcPtr)(userRoutine), uppModuleEntryProcInfo, params)
#define NewModuleEntryProc(userRoutine)	\
		(ModuleEntryProcUPP) NewRoutineDescriptor((ProcPtr)(userRoutine), uppModuleEntryProcInfo, GetCurrentISA())
#define NewModuleEntryProc68k(userRoutine)	\
		(ModuleEntryProcUPP) NewRoutineDescriptor((ProcPtr)(userRoutine), uppModuleEntryProcInfo, (ISAType) kM68kISA)
#define WTF() DebugStr("\p  USESROUTINEDESCRIPTORS");
#else
typedef ModuleProc 			ModuleEntryProcUPP;
#define CallModuleEntryProc(userRoutine, params)	\
		(*(userRoutine))(params)
#define NewModuleEntryProc(userRoutine)	\
		(ModuleEntryProcUPP)(userRoutine)
#define NewModuleEntryProc68k(userRoutine)	\
		(ModuleEntryProcUPP)(userRoutine)
#define WTF() DebugStr("\p! USESROUTINEDESCRIPTORS");
#endif
