/*
	File Name:	dlogutils.c
*/

#include "dlogutils.h"

/*******************************************************************************

	SetDialogItemState

*******************************************************************************/

void SetDialogItemState(DialogPtr dlg, short controlNumber, short value)
{
	short	iKind;
	Handle	iHandle;
	Rect	iRect;
	
	GetDItem(dlg, controlNumber, &iKind, &iHandle, &iRect);
	SetCtlValue((ControlHandle) iHandle, value);
}

/*******************************************************************************

	GetDialogItemState

*******************************************************************************/

short GetDialogItemState(DialogPtr dlg, short controlNumber)
{
	short	iKind;
	Handle	iHandle;
	Rect	iRect;
	
	GetDItem(dlg, controlNumber, &iKind, &iHandle, &iRect);
	return GetCtlValue((ControlHandle) iHandle);
}

/*******************************************************************************

	DoRadioGroup

*******************************************************************************/

void DoRadioGroup(DialogPtr dlg, short lo, short hi, short on)
{
	short i;
	
	for (i=lo;i<=hi;++i)
		SetDialogItemState(dlg, i, 0);
	SetDialogItemState(dlg, on, 1);
}

/*******************************************************************************

	DoRadioGroup

*******************************************************************************/

short GetRadioFromGroup(DialogPtr dlg, short lo, short hi)
{
	short i;
	
	for (i=lo;i<=hi;++i) {
		if (GetDialogItemState(dlg, i))
			return i;
	}
	return 0;
}

/*******************************************************************************

	ToggleCheckBox

*******************************************************************************/

void ToggleCheckBox(DialogPtr dlg, short buttonNumber)
{
	short newState;
	
	if (GetDialogItemState(dlg, buttonNumber) == 0)
		newState = 1;
	else
		newState = 0;
	SetDialogItemState(dlg, buttonNumber, newState);
}

/*******************************************************************************

	EnableControl

*******************************************************************************/

void EnableControl(DialogPtr dlg, short controlNumber)
{
	short	iKind;
	Handle	iHandle;
	Rect	iRect;
	
	GetDItem(dlg, controlNumber, &iKind, &iHandle, &iRect);
	HiliteControl((ControlHandle)iHandle, 0);
}

/*******************************************************************************

	DisableControl

*******************************************************************************/

void DisableControl(DialogPtr dlg, short controlNumber)
{
	short	iKind;
	Handle	iHandle;
	Rect	iRect;
	
	GetDItem(dlg, controlNumber, &iKind, &iHandle, &iRect);
	HiliteControl((ControlHandle)iHandle, 255);
}
