/*
	File Name:	init.c
*/

#include <GestaltEqu.h>

#include "globs.h"
#include "ae.h"
#include "prefs.h"
#include "utils.h"
#include "init.h"

/********************************************************************

	InitMacintosh
	
********************************************************************/

void InitMacintosh(void)
{
	unsigned long randSeed;
	
	InitGraf(&qd.thePort);
	InitFonts();
	FlushEvents(everyEvent, 0);
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(nil);
	InitCursor();
	GetDateTime((unsigned long *)&randSeed);
	LMSetRndSeed(randSeed);
	DrawMenuBar();
}

/********************************************************************

	InitGlobals
	
********************************************************************/

void InitGlobals(void)
{	
	OSErr	err = noErr;
	long	response;
	
	gInIdle = false;
	gDone = false;
	gInBackground = false;
	gSleepTime = kSleepTime;
	if (PowerPCPresent())
		gCodeCallPreference = itemPowerPCRadio;
	else
		gCodeCallPreference = item68kRadio;	// only one choice when running on 68k
	
	/* check for proper system version */
	err = Gestalt(gestaltSystemVersion, &response);
	if ((err != noErr) || (response < kMinimumSystem)) {
		StopAlert(alertNeedSystem7OrLater, nil);
		ExitToShell();
	}
	
	/* add menus and configure apple menu */
	{
		Handle menuBar = GetNewMBar(menubarResID);
		if (!menuBar) {
			StopAlert(alertMenuBarResourceNotFound, nil);
			ExitToShell();
		}
		SetMenuBar(menuBar);
		DisposHandle(menuBar);
		AddResMenu(GetMHandle(menuApple), 'DRVR');
		DrawMenuBar();
	}
	
	/* initialize apple events */
	err = InitAE();
	if (err != noErr) {
		NumToString((long)err, gStr);
		ParamText(gStr, "\p", "\p", "\p");
		StopAlert(alertInitAEError, nil);
		ParamText("\p", "\p", "\p", "\p");
		ExitToShell();
	}
}