/*
	File Name:	prefs.c
*/

#include "globs.h"
#include "dlogutils.h"
#include "utils.h"
#include "prefs.h"


/********************************************************************

	DoPreferences

********************************************************************/

void DoPreferences(void)
{
	DialogPtr	d;
	Boolean		done = false;
	short		itemHit;
	
	d = GetNewDialog(dlogPreferencesID, nil, (WindowPtr)-1);
	if (d == nil) return;
	
	SetDialogDefaultItem(d, ok);
	SetDialogCancelItem(d, cancel);
	
	DoRadioGroup(d, item68kRadio, itemNoModeSwitchRadio, gCodeCallPreference);
	
	// if we are running on a 68k, we don't have much choice
	if (!PowerPCPresent()) {
		DisableControl(d, itemPowerPCRadio);
		DisableControl(d, itemNoModeSwitchRadio);
	}

	ShowWindow(d);
	
	while (!done) {
		ModalDialog(nil, &itemHit);
		switch(itemHit) {
			case ok:
				gCodeCallPreference = GetRadioFromGroup(d, item68kRadio, itemNoModeSwitchRadio);
				// no break
			case cancel:
				done = true;
				break;
			case item68kRadio:
			case itemPowerPCRadio:
			case itemNoModeSwitchRadio:
				DoRadioGroup(d, item68kRadio, itemNoModeSwitchRadio, itemHit);
				break;
		}
	}
	DisposeDialog(d);
}