/*
	File Name:	utils.c
*/

#include <GestaltEqu.h>
#include "utils.h"

/********************************************************************

	PowerPCPresent
		
********************************************************************/

Boolean PowerPCPresent(void)
{
	long 	response;
	return 	((Gestalt(gestaltSysArchitecture, &response) == noErr) &&
			(response == gestaltPowerPC));
}			

/********************************************************************

	CFMPresent
		
********************************************************************/

Boolean CFMPresent(void)
{
	long 	response;
	return	(Gestalt(gestaltCFMAttr, &response) == noErr && 
			(response & (1 << gestaltCFMPresent)) != 0);
}

/********************************************************************

	IsAppWindow
	
********************************************************************/

Boolean IsAppWindow(WindowPtr window)
{
	if (window == nil)	
		return false;
	else
		return (((WindowPeek) window)->windowKind >= 0);
} 

/********************************************************************

	IsDAWindow
	
********************************************************************/

Boolean IsDAWindow(WindowPtr window)
{
	if (window == nil )
		return false;
	else
		return (((WindowPeek) window)->windowKind < 0);
} 
