/*
	File Name:	common.h
*/

#pragma once

/*** includes ***********************************************************/

#include <Processes.h>
#include "allcommon.h"

/*** definitions ********************************************************/

#define kPPCFragmentName		"\pMenuScript Fragment"
#define kMenuSelectFunctionName "\pMenuSelectPPC"
#define kMenuKeyFunctionName 	"\pMenuKeyPPC"
#define kSystemMenuFunctionName	"\pSystemMenuPPC"
#define kGlobalsSymbolName		"\pgGlobalsPtr"

#define rErrorStringListID		129
#define aGetAppDirID			1
#define aGetMenuHandle			2
#define aOpenSelection			3

/*** typedefs ***********************************************************/

#ifdef powerc
	#pragma options align=mac68k
#endif

typedef struct {
	long				menuScriptsFolderDirID;
	long				anyApplicationFolderDirID;
	UniversalProcPtr	oldMenuSelectAddr;
	UniversalProcPtr	oldMenuKeyAddr;
	UniversalProcPtr	oldSystemMenuAddr;
	FSSpec				ourFSSpec;
	Preferences			preferences;
} Globals, *GlobalsPtr, **GlobalsHdl;

#ifdef powerc
	#pragma options align=reset
#endif

enum
{
	kMenuSelectProcInfo = kPascalStackBased
				| RESULT_SIZE(SIZE_CODE(sizeof(long)))
				| REGISTER_RESULT_LOCATION(kRegisterD0)
				| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(Point))),
	kMenuKeyProcInfo = kPascalStackBased
				| RESULT_SIZE(SIZE_CODE(sizeof(long)))
				| REGISTER_RESULT_LOCATION(kRegisterD0)
				| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(short))),
	kSystemMenuProcInfo = kPascalStackBased
				| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(long)))
};

/*** function prototypes ************************************************/

OSErr 	DoMenuPatchStuff(long menuResult, GlobalsPtr gp);
#define kOpenItem			true
#define kShowItem			false
OSErr 	OpenSelection(FSSpecPtr fsp, Boolean openOption);
OSErr 	GetPSN(OSType creator, OSType type, ProcessSerialNumber *process);
OSErr 	GetDirectoryID(FSSpecPtr fsp, long *dirID);
void 	ShowErrorAlert(FSSpecPtr fsp, short action, OSErr err);

