/*
	File Name:	PPCPatches.c
*/

/*** includes ***********************************************************/

#include <GestaltEqu.h>
#include <Errors.h>
#include <Folders.h>
#include <FragLoad.h>
#include <MixedMode.h>
#include <ConditionalMacros.h>

#include "PPCPatches.h"
#include "common.h"

/*** global variables ***************************************************/

GlobalsPtr		gGlobalsPtr = nil;

/*************************************************************************

	MenuSelectPPC

*************************************************************************/

#define CallMenuSelect(pt)	CallUniversalProc(gGlobalsPtr->oldMenuSelectAddr, kMenuSelectProcInfo, pt)

pascal long MenuSelectPPC(Point startPt)
{
	long		result;
	OSErr		err = noErr;
		
	//
	// call the original MenuSelect first to see what was selected
	//
	
	result = CallMenuSelect(startPt);
	
	//
	// examine the menu selection
	//
	
	if ((result != 0L) && (gGlobalsPtr->preferences.fEnabled)) {
		err = DoMenuPatchStuff(result, gGlobalsPtr);
		if (err == noErr) 
			result = 0L;
	}
	
	return result;
}


/*************************************************************************

	MenuKeyPPC

*************************************************************************/

#define CallMenuKey(ch)	CallUniversalProc(gGlobalsPtr->oldMenuKeyAddr, kMenuKeyProcInfo, ch)

pascal long MenuKeyPPC(short ch)
{
	long		result;
	OSErr		err = noErr;
		
	//
	// call the original MenuSelect first to see what was selected
	//
	
	result = CallMenuKey(ch);
	
	//
	// examine the menu selection
	//
	
	if ((result != 0L) && (gGlobalsPtr->preferences.fEnabled)) {
		err = DoMenuPatchStuff(result, gGlobalsPtr);
		if (err == noErr) 
			result = 0L;
	}
	
	return result;
}

/*************************************************************************

	SystemMenuPPC

*************************************************************************/

#define CallSystemMenu(menuResult)	CallUniversalProc(gGlobalsPtr->oldSystemMenuAddr, kSystemMenuProcInfo, menuResult)

pascal 	void SystemMenuPPC(long menuResult)
{
	OSErr		err = noErr;
	
	//
	// examine the menu selection
	//
	
	if ((menuResult != 0L) && (gGlobalsPtr->preferences.fEnabled)) {
		err = DoMenuPatchStuff(menuResult, gGlobalsPtr);
		if (err == noErr) 
			menuResult = 0L;
	}

	//
	// call the original SystemMenu if we didnt handle it
	//
	
	if (((err == fnfErr) || (err == noErr)) && (menuResult != 0L))
		CallSystemMenu(menuResult);
}