/*
	File Name:		RefConLDEF.c
*/

#include "RefConLDEF.h"

/*************************************************************************

	function prototypes

*************************************************************************/

void DrawMsg(Boolean fSelect, Rect *r, Cell cell, ListHandle lh);
void HiliteMsg(Boolean fSelect, Rect *r);

/*************************************************************************

	main

*************************************************************************/

pascal void main(short message, Boolean fSelect, Rect *r, Cell cell,
				 short dataOffset, short dataLen, ListHandle lh)
{

	switch(message) {
		case lInitMsg:
			break;
		
		case lDrawMsg:
			DrawMsg(fSelect, r, cell, lh);
			break;
		
		case lHiliteMsg:
			HiliteMsg(fSelect, r);
			break;
			
		case lCloseMsg:
			break;

		default:
			break;
	}
}

/*************************************************************************

	DrawMsg

*************************************************************************/

void DrawMsg(Boolean fSelect, Rect *r, Cell cell, ListHandle lh)
{
	RefconLDEFCell	cellData;
	short			dataLen;

	// get cell	
	dataLen = (short)sizeof(cellData);
	LGetCell((Ptr)(&cellData), &dataLen, cell, lh);
	
	// call draw proc
	if (cellData.drawProc) {
		EraseRect(r);
		CallRefconLDEFDrawProc(cellData.drawProc, r, cell, lh, cellData.refCon);
	}
	
	// hilite if selected
	if (fSelect)
		HiliteMsg(fSelect, r);
}

/*************************************************************************

	HiliteMsg

*************************************************************************/

void HiliteMsg(Boolean fSelect, Rect *r)
{
	unsigned char	hMode;

	hMode = LMGetHiliteMode();
	BitClr((Ptr)(&hMode),(long)pHiliteBit);
	LMSetHiliteMode(hMode);
	InvertRect(r);
}
