/*
	File Name:	ViewByNameLDEF.h
*/

#pragma once

#define dlogMainID				128
#define itemQuit				1
#define itemList				3

#define rFolderIcon				128
#define rArrowOpenedIcon		129
#define rArrowClosedIcon		130

#define kCellHeight 			18
#define kNumColumns				1
#define kNumRows				0

#define kScrollBarWidth			15

typedef struct ListItem {
	FSSpec			spec;			// file/folder specification
	short			iconID;			// id of icon to draw for it
	unsigned char	indentLevel;	// level of indentation
	unsigned char	isOpen;			// if a folder, whether it is open or closed
} ListItem, *ListItemPtr, **ListItemHdl;

#define kAddToEnd 32767
void	FillList(short vRefNum, long dirID, ListHandle theList, short beforeThisRow, short indentLevel);
void 	HandleClickOnList(DialogPtr d, ListHandle theList);
void 	ListElementProc(Rect *cellRect, Cell lCell, ListHandle theList, long refCon);

pascal 	void DrawFrame(DialogPtr d, short theItem);
void 	GetDialogItemRect(DialogPtr dlg, short itemNumber, Rect *r);
void 	SetWindowFont(DialogPtr d, short fontNum, short fontSize, Style fontStyle, short fontMode);
void 	SetUserItemProc(DialogPtr dlg, short userItem, ProcPtr userProc);
void 	ShowError(OSErr errorCode, unsigned char * errorStr);
long 	GetDirectoryID(FSSpec *spec);
Boolean TrackIconByRect(Rect *drawRect, Rect *trackRect, short iconID);
short 	GetIconID(OSType fileType);
Boolean AnyCellsSelected(ListHandle lh, Cell *theCell);
OSErr 	DrawFileIcon(FSSpec *spec, Rect *drawRect);
