/*
	File Name:	Icon Family CDEF.c
*/

/*
	Icon Family CDEF
	
	Variation codes:
	
	0 : MIN = id of icon
		MAX = id of pressed icon
	1:	MIN = id of icon, uses ttSelected when pressed
*/

#include <Icons.h>
#include <Controls.h>

#ifdef __powerc
	ProcInfoType __procInfo = uppControlDefProcInfo;		
#endif

void	Draw(short varCode, ControlHandle control, long param);
long	Test(ControlHandle control, long param);
void	CalcRegions(ControlHandle control, long param);

/*************************************************************************

	main

*************************************************************************/

pascal long	main(short varCode, ControlHandle control, short message, long param)
{
	long result = 0L;
	
	switch(message) {
	
		case drawCntl:
			Draw(varCode, control, param);
			break;
			
		case testCntl:
			result = Test(control, param);
			break;
			
		case calcCntlRgn:
			CalcRegions(control, param);
			break;
			
		case initCntl:
		case dispCntl:
		case calcThumbRgn:
		case posCntl:
		case thumbCntl:
		case dragCntl:
		case autoTrack:
		default:
			break;
	}

	return result;
}

/*************************************************************************

	Draw

*************************************************************************/

void Draw(short varCode, ControlHandle control, long param)
{
	Rect	r = (*control)->contrlRect;
	short	id, transform = ttNone;
	OSErr	whoCares = noErr;

	if ((*control)->contrlVis == 0xFF) {
		id = (*control)->contrlMin;
		if ((*control)->contrlHilite == 255) {
			transform = ttDisabled;
		} else {
			if ((*control)->contrlHilite == 0) {
				id = (*control)->contrlMin;
			} else {
				if (varCode == 0) {
					id = (*control)->contrlMax;
				} else {
					id = (*control)->contrlMin;
					transform = ttSelected;
				}
			}
		}
		whoCares = PlotIconID(&r, atAbsoluteCenter, transform, id);
	}
}

/*************************************************************************

	Test

*************************************************************************/

long Test(ControlHandle control, long param)
{
	Rect	r = (*control)->contrlRect;
	Point	hitPt;
	long	result;
	
	hitPt.h = LoWord(param);
	hitPt.v = HiWord(param);
	if ((*control)->contrlHilite == 255) {
		result = 0L;
	} else {
		if (PtInRect(hitPt, &r))
			result = inButton;
		else
			result = 0L;
	}
	
	return result;
}

/*************************************************************************

	CalcRegions

*************************************************************************/

void CalcRegions(ControlHandle control, long param)
{
	Rect r = (*control)->contrlRect;
	param = param & 0x7FFFFFFF;
	RectRgn((RgnHandle)param, &r);
}
