// *****************************************************************************
//
//	WindoidTypes.h
//
// 
//	Copyright  1991-94 Infinity Systems.  All rights reserved.
// 
#ifndef Infinity_WINDOIDTYPES
#define Infinity_WINDOIDTYPES

#include "WindoidDefines.h"

#include <Types.h>
#include <Windows.h>


// *****************************************************************************
//
//	Constants
//
// *****************************************************************************

// 
//
//	Apple System 7.5 style variations	
//
// 
enum {
	kSystem75_toggleTBar = 1,	// Bit 0 tells us whether to hilite/unhilite 
								//       the title bar.
	kSystem75_hasGrow	 = 2,	// Bit 1 is the grow bit.
	kSystem75_hasZoom	 = 4,	// Bit 2 is the zoom bit.
	kSystem75_vertTBar	 = 8	// Bit 3 set if titlebar is vertical.
};


// *****************************************************************************
//
//	Structures
//
// *****************************************************************************
typedef struct {
	WStateData		wState;
	unsigned char	closeToggle;
	unsigned char	zoomToggle;
	unsigned char	isHoriz;
	unsigned char	ignoreHilite;
	unsigned char	hasGrow;
} WindoidData, *WindoidDataPtr, **WindoidDataHandle;


// 
//
//	Accessor Macro
//
// 
#define WindData (**(WindoidDataHandle) window->dataHandle)
	// This macro is used so I can access the globals easily. Note: the
	// variable containing the window must be named window, and it must be in
	// scope at the time of the usage of this macro.  Also, they arent REALLY 
	// globals, becuase theyre kept for EACH window.


// 
#endif