/*
	File Name:		PPCGlue.c
*/

/*
	The information in this file is straight from 
	Technical Note QT 05 - Component Manager version 3.0
*/

#include "FatComponent.h"
#include "FatComponentPrivate.h"
#include <Menus.h>
#include <Windows.h>
#include <QuickDraw.h>
#include <OSEvents.h>
#include <Resources.h>
#include <Desk.h>
#include <Fonts.h>
#include <ToolUtils.h>
#include <Components.h>
#include <QuickTimeComponents.h>

// in InterfaceLib but was left out of headers
extern UniversalProcPtr CallComponentUPP;

// this lets us call our component from PowerPC code
enum {
    uppCallComponentProcInfo = kPascalStackBased
		| RESULT_SIZE(kFourByteCode)
		| STACK_ROUTINE_PARAMETER(1, kFourByteCode)
};

// we must have this glue in order to call our component from PowerPC code since
// the Component Manager allows you to create your own routines. we must mimic the
// 68k inline code that our 680x0 tester uses so we create one of these glue routines
// for each of our custom functions.
pascal ComponentResult DoBeep(FatComponent fatInstance, short inBeepTimes, short *outBeepTimes) 
{
#define kDoBeepParamSize (sizeof(DoBeepParams))

#ifdef powerc
#pragma options align=mac68k
#endif

   struct DoBeepParams {
		short			*outBeepTimes;
		short			inBeepTimes;
   };
   typedef struct DoBeepParams DoBeepParams;
   
   struct DoBeepGluePB {
		unsigned char		componentFlags;		/* Flags - set to zero */
		unsigned char		componentParamSize;	/* Size of the params struct */
		short				componentWhat;		/* The component request selector */
		DoBeepParams		params;				/* The parameters, see above */
		ComponentInstance	instance;			/* This component instance */
   };
   typedef struct DoBeepGluePB DoBeepGluePB;

#ifdef powerc
#pragma options align=reset
#endif

   DoBeepGluePB	myDoBeepGluePB;
   myDoBeepGluePB.componentFlags = 0;
   myDoBeepGluePB.componentParamSize = kDoBeepParamSize;
   myDoBeepGluePB.componentWhat = kDoBeepSelect;
   myDoBeepGluePB.params.outBeepTimes = outBeepTimes;
   myDoBeepGluePB.params.inBeepTimes = inBeepTimes;
   myDoBeepGluePB.instance = (ComponentInstance)fatInstance;
   
   return CallUniversalProc(CallComponentUPP, uppCallComponentProcInfo, &myDoBeepGluePB);
}

pascal ComponentResult DoFlash(FatComponent fatInstance, short inFlashTimes, long inDelayTime, short *outFlashTimes) 
{
#define kDoFlashParamSize (sizeof(DoFlashParams))

#ifdef powerc
#pragma options align=mac68k
#endif

   struct DoFlashParams {
		short			*outFlashTimes;
		long 			inDelayTime;
		short			inFlashTimes;
   };
   typedef struct DoFlashParams DoFlashParams;
   
   struct DoFlashGluePB {
		unsigned char		componentFlags;		/* Flags - set to zero */
		unsigned char		componentParamSize;	/* Size of the params struct */
		short				componentWhat;		/* The component request selector */
		DoFlashParams		params;				/* The parameters, see above */
		ComponentInstance	instance;			/* This component instance */
   };
   typedef struct DoFlashGluePB DoFlashGluePB;

#ifdef powerc
#pragma options align=reset
#endif

   DoFlashGluePB	myDoFlashGluePB;
   myDoFlashGluePB.componentFlags = 0;
   myDoFlashGluePB.componentParamSize = kDoFlashParamSize;
   myDoFlashGluePB.componentWhat = kDoFlashSelect;
   myDoFlashGluePB.params.outFlashTimes = outFlashTimes;
   myDoFlashGluePB.params.inDelayTime = inDelayTime;
   myDoFlashGluePB.params.inFlashTimes = inFlashTimes;
   myDoFlashGluePB.instance = (ComponentInstance)fatInstance;
   
   return CallUniversalProc(CallComponentUPP, uppCallComponentProcInfo, &myDoFlashGluePB);
}
