/*
	File Name:		FatComponent.h
*/

#pragma once

#include <QuickTimeComponents.h>

#define	fatComponentType 'PHAT'

// Math component request codes
enum
{
	kDoBeepSelect = 1,
	kDoFlashSelect
};

typedef	ComponentInstance FatComponent;

#ifdef __cplusplus
extern "C" {
#endif __cplusplus

pascal ComponentResult DoBeep(FatComponent fatInstance, short inBeepTimes, short *outBeepTimes)
	ComponentCallNow(kDoBeepSelect, sizeof(short) + sizeof(short*));
	
pascal ComponentResult DoFlash(FatComponent fatInstance, short inFlashTimes, long inDelayTime, short *outFlashTimes)
	ComponentCallNow(kDoFlashSelect, sizeof(short) + sizeof(long) + sizeof(short*));

#ifdef __powerc
#define CallComponentFunctionWithStorageUniv(storage, params, funcName) \
   CallComponentFunctionWithStorage(storage, params, &funcName##RD)
#define CallComponentFunctionUniv(params, funcName) \
   CallComponentFunction(params, &funcName##RD)
#define INSTANTIATE_ROUTINE_DESCRIPTOR(funcName) RoutineDescriptor funcName##RD = \
   BUILD_ROUTINE_DESCRIPTOR (upp##funcName##ProcInfo, funcName)
#else
#define CallComponentFunctionWithStorageUniv(storage, params, funcName) \
   CallComponentFunctionWithStorage(storage, params, (ComponentFunctionUPP)funcName)
#define CallComponentFunctionUniv(params, funcName) \
   CallComponentFunction(params, (ComponentFunctionUPP)funcName)
#endif

enum {
	uppFatOpenProcInfo = kPascalStackBased
		 | RESULT_SIZE(SIZE_CODE(sizeof(ComponentResult)))
		 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(ComponentInstance)))
};

enum {
	uppFatCloseProcInfo = kPascalStackBased
		 | RESULT_SIZE(SIZE_CODE(sizeof(ComponentResult)))
		 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Handle)))
		 | STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(ComponentInstance)))
};

enum {
	uppFatCanDoProcInfo = kPascalStackBased
		 | RESULT_SIZE(SIZE_CODE(sizeof(ComponentResult)))
		 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(short)))
};

enum {
	uppFatVersionProcInfo = kPascalStackBased
		 | RESULT_SIZE(SIZE_CODE(sizeof(ComponentResult)))
};

enum {
	uppFatTargetProcInfo = kPascalStackBased
		 | RESULT_SIZE(SIZE_CODE(sizeof(ComponentResult)))
		 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Handle)))
		 | STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(ComponentInstance)))
};

enum {
	uppFatDoBeepProcInfo = kPascalStackBased
		 | RESULT_SIZE(SIZE_CODE(sizeof(ComponentResult)))
		 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(short)))
		 | STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(short*)))
};

enum {
	uppFatDoFlashProcInfo = kPascalStackBased
		 | RESULT_SIZE(SIZE_CODE(sizeof(ComponentResult)))
		 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(short)))
		 | STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(long)))
		 | STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(short*)))
};
 
#ifdef __cplusplus
}
#endif __cplusplus
