/*
	File Name:		FatComponent.c
*/

/*
	Assumes QuickTime 2.0 or later and Component Manager 3.0 or later.
*/

#include "FatComponent.h"
#include "FatComponentPrivate.h"
#include "FatComponentCommon.h"
#include <Errors.h>
#ifndef __powerc
	#include <A4Stuff.h>
#endif

pascal ComponentResult main (ComponentParameters *params, Handle storage);

#ifdef __powerc
	INSTANTIATE_ROUTINE_DESCRIPTOR(FatCanDo);
	INSTANTIATE_ROUTINE_DESCRIPTOR(FatOpen);
	INSTANTIATE_ROUTINE_DESCRIPTOR(FatClose);
	INSTANTIATE_ROUTINE_DESCRIPTOR(FatVersion);
	
	INSTANTIATE_ROUTINE_DESCRIPTOR(FatDoBeep);
	INSTANTIATE_ROUTINE_DESCRIPTOR(FatDoFlash);

	RoutineDescriptor MainRD = BUILD_ROUTINE_DESCRIPTOR(uppComponentRoutineProcInfo, main);
	ProcInfoType __procinfo = uppComponentRoutineProcInfo;
#endif

pascal ComponentResult main (ComponentParameters *params, Handle storage)
{
	ComponentResult	result = noErr;

#ifndef __powerc
	long oldA4;
	oldA4 = SetCurrentA4();
#endif

	// Did we get a Component Manager request code (< 0)?
	if (params->what < 0) {
		switch (params->what) {
			case kComponentOpenSelect:
				result = CallComponentFunctionUniv(params, FatOpen);
				break;
			
			case kComponentCloseSelect:
				result = CallComponentFunctionWithStorageUniv(storage, params, FatClose);
				break;	
			
			case kComponentCanDoSelect:
				result = CallComponentFunctionUniv(params, FatCanDo);
				break;	
			
			case kComponentVersionSelect:
				result = CallComponentFunctionUniv(params, FatVersion);
				break;	
			
			case kComponentRegisterSelect: 	// not supported
			default:						// unknown
				result = paramErr;
				break;
		}
	} else {								// one of ours
		switch (params->what) {
			case kDoBeepSelect:
				result = CallComponentFunctionUniv(params, FatDoBeep);
				break;	

			case kDoFlashSelect:
				result = CallComponentFunctionUniv(params, FatDoFlash);
				break;	
			
			default:						// unknown
				result = paramErr;
				break;
		}
	}

#ifndef __powerc
	SetA4(oldA4);
#endif

	return result;
}
											 
