/*
	File Name:		RefConLDEF.h
*/

#pragma once

#define kRefConLDEFID 128	// resource id of our LDEF resource

typedef void (*RefconLDEFDrawProcType)(Rect *r, Cell cell, ListHandle lh, long refCon);

enum {
	uppRefconLDEFDrawProcInfo = kCStackBased
		 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Rect *)))
		 | STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(Cell)))
		 | STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(ListHandle)))
		 | STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof(long)))
};

#if USESROUTINEDESCRIPTORS
typedef UniversalProcPtr RefconLDEFDrawProcUPP;

#define CallRefconLDEFDrawProc(userRoutine, r, cell, lh, refCon)		\
		CallUniversalProc((UniversalProcPtr)(userRoutine), uppRefconLDEFDrawProcInfo, r, cell, lh, refCon)
#define NewRefconLDEFDrawProc(userRoutine)		\
		(RefconLDEFDrawProcUPP) NewRoutineDescriptor((ProcPtr)(userRoutine), uppRefconLDEFDrawProcInfo, GetCurrentISA())
#else
typedef RefconLDEFDrawProcType RefconLDEFDrawProcUPP;

#define CallRefconLDEFDrawProc(userRoutine, r, cell, lh, refCon)		\
		(*(userRoutine))(r, cell, lh, refCon)
#define NewRefconLDEFDrawProc(userRoutine)		\
		(RefconLDEFDrawProcUPP)(userRoutine)
#endif

typedef struct RefconLDEFCell {
	long					refCon;
	RefconLDEFDrawProcUPP	drawProc;
} RefconLDEFCell, *RefconLDEFCellPtr, **RefconLDEFCellHdl;
